/* DuduSDL
 * dudusdl.c
 *
 * Copyright (C) 2000 Nicolas Peninguy and Colin Leroy
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "dudusdl.h"
#include <sys/time.h>

int jeu(void);

SDL_Surface * images[NB_IMAGES];
SDL_Surface * screen;

SDL_Surface * clean_p1;
SDL_Surface * clean_p2;
SDL_Surface * clean_p3;
SDL_Surface * clean_p4;

SDL_Rect    * dest;
SDL_Rect    * trect;
SDL_Event event;
long double lasttime = 0;
int laisse_moi=0;
int tour=0;
int sens=1;
int depsens=1;
int boulecours=0;
int maxAccr=0;
int dbouge[4]={1,1,1,1};
int CPUtire=0;
int deg[4]={0,0,0,0};
int PLATEAU=100,VERIN=101;
int PERDU=50,GAGNE=51;
int REBOURS=84;
int MALUS_ROUGE=12,MALUS_JAUNE=13;
char EXPLOSION=6;
char FIN_EXPLOSION=7;
int ENGR=240;
int maxBoulesEnvoyees=0;
int meilleurJoueur=0;
int scoreJoueur[4]={0,0,0,0};
char nombreCoups[4]={0,0,0,0};
float mindist=1000;
int toucheTir[4]={SDLK_SPACE,SDLK_LCTRL,SDLK_KP0,SDLK_TAB};
int toucheGauche[4]={SDLK_LEFT,SDLK_z,SDLK_KP7,SDLK_q};
int toucheDroite[4]={SDLK_RIGHT,SDLK_c,SDLK_KP9,SDLK_e};
int toucheHaut[4]={SDLK_UP,SDLK_d,SDLK_KP_DIVIDE,SDLK_w};
int toucheMessage[4]={SDLK_DELETE,SDLK_x,SDLK_KP_MULTIPLY,SDLK_AMPERSAND};
int comment_delay = 0;
char message[12][21]=
{	"Abruti !",
	"Salopard !",
	"Petit merdeux !",
	"Eh ducon !",
	"Zoophile !",
	"Moule a gaufres !",
	"Sucker !",
	"Loser !",
	"Tu vas perdre",
	"Cornichon diplome",
	"Casse toi",
	"tu vas prendre..."
};
char comment[12][30]=
{	"Ca tue...",
	"ouh. encore un coup du ciel",
	"De mieux en mieux...",
	"Attention, il est en forme",
	"mefiez vous de la suite...",
	"ca fait du bien...",
	"Robin des Bulles...",
	"Il se donne a fond.",
	"Et ca commence a peine",
	"Ca va durer longtemps ?",
	"May the force be with you",
	"la chance ne dure jamais."
};
int LIBRE=747;
int gravite=0;
int vitesseAxeY=4;
int viseurCoordX[4]={534,98,534,98},viseurCoordY[4]={227,227,467,467};
int tableauJeu[4][4]={{438,638,11  ,235},
		   {2  ,202,11  ,235},
		   {438,638,251,475},
		   {2,  202,251,475}};
char bouleEtatExistence[4]={6,6,6,6};
int tremblement[4]={0,0,0,0};
int continuer=1;
char joueurVivant[4]={1,1,1,1};
int nbBoulesMalusRecuees[4]={0,0,0,0};
float angle=0;
float a[4]={3.1415/2,3.1415/2,3.1415/2,3.1415/2};
char degreDescente[4]={0,0,0,0};

int maxHauteur = 600;

int gauche[4] = {0,0,0,0};
int droite[4] = {0,0,0,0};
int haut[4] = {0,0,0,0};
int tire[4] = {0,0,0,0};
int mess[4] = {0,0,0,0};
int escape = 0;

int main( int argc, char *argv[] )
{
  int i;
  int numeroJoueur;
  videoflags = SDL_SWSURFACE;
  
  while ( argc > 1 ) {
    --argc;
    if ( strcmp(argv[argc], "-hw") == 0 )
      videoflags ^= SDL_HWSURFACE;
    else if ( strcmp(argv[argc], "-flip") == 0 )
      videoflags ^= SDL_DOUBLEBUF;
    else if ( strcmp(argv[argc], "-fullscreen") == 0 )
      videoflags ^= SDL_FULLSCREEN;
    else {
      fprintf(stderr, 
	      "Usage: %s [-hw] [-flip] [-fullscreen]\n",
	      argv[0]);
      exit(1);
    }
  }
  trect = malloc(sizeof(SDL_Rect));
  
  demander_parametres();
  charger_donnes();
  dest = malloc(sizeof(SDL_Rect));
  dest->x = 0;
  dest->y = 0;
  dest->w =images[11]->w;
  dest->h =images[11]->h;
  
  if (nombreJoueurs == 0)
    {
      tableauJeu[0][0] = 220;
      tableauJeu[0][1] = 420;
      tableauJeu[0][2] = 128;
      tableauJeu[0][3] = 352;
      viseurCoordX[0] = 320;
      viseurCoordY[0] = 344;
    }
  if (nombreJoueurs == 1)
    {
      tableauJeu[0][0] = 420;
      tableauJeu[0][1] = 620;
      tableauJeu[0][2] = 128;
      tableauJeu[0][3] = 352;
      tableauJeu[1][0] = 20;
      tableauJeu[1][1] = 220;
      tableauJeu[1][2] = 128;
      tableauJeu[1][3] = 352;
      viseurCoordX[0] = 520;
      viseurCoordY[0] = 344;
      viseurCoordX[1] = 120;
      viseurCoordY[1] = 344;
    }
    

/*  setcolor (screen, 0, 0, 0, 0);
    
  SDL_SetColorKey(screen, 0, 0);
  SDL_SetColorKey(images[11], 0, 0);
  */
  tempsTotal = time (NULL);
  lastangle = 3.14;
  
  //boucle principale de Jeu
  while (continuer)
    {
      nombreJoueursVivants = nombreJoueurs + 1;
      temps = time (NULL);
     // ClearBuffer (0);
      initialiser_tableau ();
      numeroJoueur = 0;
      premierTick = time (NULL);
      
      continuer = jeu();
    }
  
  return 0;
}


int jeu( void )
{ 
  SDL_Event event;
  int continuer = 1;
  int joueur = 0;
  SDLKey key;
  struct timeval tv;
  
  SDL_EnableKeyRepeat(0, 0);
  SDL_ShowCursor(0);
  reset_screen ();
  
  while (continuer) {
    SDL_BlitSurface(images[11], NULL, screen, dest);
    while (SDL_PollEvent(&event)) {
      switch (event.type) {
      case SDL_KEYDOWN:
	switch (event.key.keysym.sym) {
	case SDLK_ESCAPE:
	  escape = 1;
	  break;
	default:
	  key = event.key.keysym.sym;
	  do {
	    if (toucheGauche[joueur]==key)
	      gauche[joueur] = 1;
	    else if (toucheDroite[joueur]==key)
	      droite[joueur] = 1;
	    else if (toucheHaut[joueur]==key)
	      haut[joueur] = 1;
	    else if (toucheTir[joueur]==key)
	      tire[joueur] = 1;
	    else if (toucheMessage[joueur]==key)
	      mess[joueur] = 1;
	  } while((joueur = changer_joueur(joueur)) != 0);
	  break;
	}
	break;
      case SDL_KEYUP:
	do {
	  key = event.key.keysym.sym;
	  if (toucheGauche[joueur]==key)
	    gauche[joueur] = 0;
	  else if (toucheDroite[joueur]==key)
	    droite[joueur] = 0;
	  else if (toucheHaut[joueur]==key)
	    haut[joueur] = 0;
	  else if (toucheTir[joueur]==key)
	    tire[joueur] = 0;
	  else if (toucheMessage[joueur]==key)
	    mess[joueur] = 0;
	} while((joueur = changer_joueur(joueur)) != 0);
	break;
      default:
	break;
      }
    }  // Fin du traitement des vnements.
    
    if(CPU && !CPUtire) {
      cpu_prepare();
    }
    do {
      bouger_viseur(joueur);
      afficher_viseur(joueur);
      test_temps(joueur);
      test_tir_bulle(joueur);
      
      if (bouleCourante[joueur] > 0
	  && bouleArrivee[joueur][bouleCourante[joueur] -
				 1] == 0)
	{
	  deplacer_bulle (joueur);
	  
	  if (bouleRebond_ou_Arrivee (joueur))
	    {
	      bouleArrivee[joueur][bouleCourante[joueur] -
					1] = 1;
	      classerBoules (joueur);
	      testerCouleursIdentiques (joueur);
	      detecterBoulesLibres (joueur);
	      if (nombreCoups[joueur] == 20 - gravite * 10)
		descendrePlateau (joueur);
	      if (nbBoulesMalusRecuees[joueur] > 0)
		recevoirBoulesMalus (joueur);
	      if (compterBoules (joueur) == 0)
		{
		  if (nombreJoueursVivants > 1)
		    {
		      for (i = 0; i <= nombreJoueurs; i++)
			if (i != joueur)
			  //mort des joueurs qui n'ont pas fini
			  joueurVivant[i] = 0;
		    }
		  else
		    {
		      for (i = 0; i <= nombreJoueurs; i++)
			joueurVivant[i] = 0;
		    }
		}
	    }
	}
	if(comment_delay)
	{	
		comment_delay--;
		if(comment_delay > 1)
			PutTXTC(0,comment[temp],100,50);
		else {
			PutTXTC(0,"                                                ",100,50);
		        SDL_BlitSurface(images[11], NULL, screen, dest);
      			SDL_UpdateRect (screen, 100, 50, 440, 20);
			
		}
		if (comment_delay==0)
			temp = -1;
	}
	
      for (i = 0; i < bouleCourante[joueur] - 1; i++)
	//detecterBoulesLibres bulles tombes
	if (bouleVitesseChute[joueur][i])
	  {
	    bouleCoordY[joueur][i] +=
	      (bouleVitesseChute[joueur][i]++);
	    if (!bouleVitesseChute[joueur][i])
	      bouleVitesseChute[joueur][i]++;
	    if (bouleCoordY[joueur][i] >
		tableauJeu[joueur][3] + 8)
	      bouleVitesseChute[joueur][i] = 0;
	  }      
      	  //preparation Descente du plateau
      if (nombreCoups[joueur] == 20 - gravite * 10
	  || nombreCoups[joueur] == 19 - gravite * 10
	  || nombreCoups[joueur] == 18 - gravite * 10)
	{
	  tremblement[joueur] += dbouge[joueur];
	  if (tremblement[joueur] >= 2)
	    {
	      dbouge[joueur] = -1;
	      tremblement[joueur] = 2;
	    }
	  if (tremblement[joueur] <= -2)
	    {
	      dbouge[joueur] = 1;
	      tremblement[joueur] = -2;
	    }
	}
      else
	tremblement[joueur] = 0;

      afficher_elements (joueur);

      //verification nombre de joueurs restants
      nombreJoueursVivants = 0;
      
      for (i = 0; i <= nombreJoueurs; i++)
	nombreJoueursVivants += joueurVivant[i];
      
      if (nombreJoueursVivants == 1 && nombreJoueurs > 0)
	for (i = 0; i <= nombreJoueurs; i++)
	  if (nombreJoueursVivants == 1 && nombreJoueurs > 0
	      && joueurVivant[i])
	    scoreJoueur[i]++;
      
      if (nombreJoueursVivants == 1 && nombreJoueurs > 0)
	{
	  quitter (i + 1);
	  break;
	}
      
      if (!compterBoules (0) && nombreJoueurs == 0)
	{
	  joueurVivant[0] = 1;
	  scoreJoueur[0]++;
	  quitter (6);
	  break;
	}
      
      if (nombreJoueursVivants == 0 && nombreJoueurs == 0)
	{
	  quitter (6);
	  break;
	}
      if (escape)
	quitter (0);
      
    } while((joueur = changer_joueur(joueur)) != 0);
    
    switch (nombreJoueurs) {
    	case 0:
		SDL_UpdateRect (screen, 
				tableauJeu[0][0],
				tableauJeu[0][2],
				tableauJeu[0][1]-tableauJeu[0][0],
				tableauJeu[0][3]-tableauJeu[0][2]);
		break;
	case 1:
		SDL_UpdateRect (screen, 
				tableauJeu[1][0],
				tableauJeu[1][2],
				tableauJeu[1][1]-tableauJeu[1][0]+30,
				tableauJeu[1][3]-tableauJeu[1][2]);
		SDL_UpdateRect (screen, 
				tableauJeu[0][0]-30,
				tableauJeu[0][2],
				tableauJeu[0][1]-tableauJeu[0][0]+30,
				tableauJeu[0][3]-tableauJeu[0][2]);
		break;
	case 2:
	case 3:
	default:
		SDL_UpdateRect (screen, 0, 0, 0, 0);
	
	
    }
    if(temp >= 0)
    	SDL_UpdateRect(screen,100,50,440,20);

    gettimeofday(&tv,0);
    //printf("time = %ld\n",tv.tv_usec);

    if(tv.tv_usec - lasttime < 15000 && tv.tv_usec - lasttime > 0 && lasttime != 0) {
      usleep (15000- (tv.tv_usec - lasttime));
      //printf("sleeping %ld\n",15000- (tv.tv_usec - lasttime));
    }
    lasttime = tv.tv_usec;

  } // while(continuer)
  
  return 0;
} // jeu
				    
int reset_screen (void) {
      SDL_BlitSurface(images[11], NULL, screen, dest);
      SDL_UpdateRect (screen, 0, 0, 0, 0);
      return 0;
}
